extern crate msgp;
#[macro_use]
extern crate serde_derive;
extern crate arrayvec;

use arrayvec::ArrayVec;

#[derive(Debug, Serialize, Deserialize)]
struct Abc<'a> {
    a: i32,
    b: u16,
    c: &'a str,
}

fn main() {
    let abc = Abc {
        a: 1,
        b: 2,
        c: "Hello, World!",
    };
    let mut buf = ArrayVec::<[u8; 512]>::new();
    msgp::write_named(&mut buf, &abc).unwrap();

    println!("{:?}", buf);

    let bcd = msgp::from_slice::<Abc>(&buf).unwrap();

    println!("{:?}", bcd);
}
